//Glover Javascript Libraryˤ롢Ajaxǽ󤷤
//GAjax饹Ԥ
//GAjax饹ϡƱ̿ˤ͡饹ʤɤ󶡤롣

var GAjax = new Object();
GAjax.READY_STATE_UNINITIALIZED = 0;
GAjax.READY_STATE_LOADING = 1;
GAjax.READY_STATE_LOADED = 2;
GAjax.READY_STATE_INTERACTIVE = 3;
GAjax.READY_STATE_COMPLETE = 4;

//GJLˤ롢Ʊ̿δܥ饹
//ɤ߽Фurlȡɤ߽Фλ˼¹ԤonloadλꤵС
//ǻꤷurlɤ߽Ф/¹ԤǤ롣
//᥽åɤ䡢顼ؿContent-Typeʤɤꤷϡ줾
//ϥåȤϢܤΰȤϤƤФ褤

GAjax.ContentLoader = function(url, onload, datas) {
	this.m_URL = url;
	this.m_Request = null;
	this.m_OnLoad = onload;
	
	this.m_OnError = (datas["onerror"]) ? datas["onerror"] : this.defaultError;
	this.m_Method = (datas["method"]) ? datas["method"] : "GET";
		
	if (!datas["ContentType"] && ( (this.m_Method == "POST") || (this.m_Method == "post") )) {
		this.m_ContentType = "application/x-www-form-urlencoded";
	} else {
		this.m_ContentType = datas["ContentType"];
	}
	
	this.m_Parameters = (datas["params"]) ? datas["params"] : null;

	this.loadXMLDoc();
}

GAjax.ContentLoader.prototype = {
	loadXMLDoc : function() {
		
		if (window.XMLHttpRequest) {
			this.m_Request = new XMLHttpRequest();
		} else if (window.ActiveXObject) {
			try {
				this.m_Request = new ActiveXObject("Msxml2.XMLHTTP");
			} catch (err) {
				this.m_Request = new ActiveXObject("Microsoft.XMLHTTP");
			}
		}
		
		if (this.m_Request) {
			try {
				var loader = this;
				this.m_Request.onreadystatechange = function() {
					loader.onReadyState.call(loader);
				}
				
				this.m_Request.open(this.m_Method, this.m_URL, true);
				if (this.m_ContentType) {
					this.m_Request.setRequestHeader("Content-Type", this.m_ContentType);
				}
				
				this.m_Request.send(this.m_Parameters);
			} catch (err) {
				this.m_OnError.call(this);
			}
		}
	},
	
	onReadyState : function() {
		var req = this.m_Request;
		var ready = req.readyState;
		if (ready == GAjax.READY_STATE_COMPLETE) {
			var httpStatus = req.status;
			if (httpStatus == 200 || httpStatus == 0) {
				this.m_OnLoad.call(this);
			} else {
				this.m_OnError.call(this);
			}
		}
	},
	
	defaultError : function() {
		alert("error fetching data!" +
			"\n\nreadyState : " + this.m_Request.readyState +
			"\nstatus: " + this.m_Request.status +
			"\nheaders: " + this.m_Request.getAllResponseHeaders());
	}
}

//****************************************************************************//
//ŪʥСݡ󥰵ǽդޥɥ塼饹
//塼줿ޥɤ
//ꤵ줿ؿĥ饹ǤΤʤ顢ʤ륪֥ȤǤäƤ⡢
//Υ塼ϿС˥ꥯȤ뤳ȤǤ롣
//Υ饹ϡޤǥС˥ꥯȤ롢ȤȤݲ뤳ȤŪǤΤǡ
//ɤ߽ФǤȡñ˥å뤳ȤǤȡɤǤ⹽ʤ
//塼ΤʣĺǤϥХʻȤˡͭIDäƥå롣
GAjax.commandQueues = new Array();

GAjax.CommandQueue = function(url, id, freq) {
	this.m_ID = id;
	this.m_URL = url;
	//ʣʤɲá
	GAJax.commandQueues[id] = this;
	
	this.m_Queue = new Array();
	this.m_SendCommand = new Array();
	
	if (freq) {
		this.repeat(freq);
	}
}

//ޥɤɲä롣
GAjax.CommandQueue.prototype.addCommand = function(command) {
	if (this.isCommand(command)) {
		//ޥɥ֥ȤѷƤ硣
		this.m_Queue.append(command, true);
	}
}

GAjax.CommandQueue.prototype.isCommand = function(command) {
	return (
		command.implementsProp("id") &&
		command.implementsFunc("toRequestString") &&
		command.implementsFunc("parseResponse")
	);
}

//塼ί줿ޥɤƤФ롣
GAjax.CommandQueue.prototype.fireRequest = function() {
	
	if (this.m_Queue.length == 0) {
		return;
	}
	
	var data = "data=";
	for (var i = 0;i < this.m_Queue.length;i++) {
		var cmd = this.m_Queue[i];
		if (this.isCommand(cmd)) {
			data += cmd.toRequestString();
			this.m_SendCommand[i] = cmd;
		}
	}
	this.m_Queue = new Array();
	
	//롣
	this.m_Loader = new ContentLoader(this.m_URL, 
		this.onLoad, {method : "POST", onerror : this. onerror});
}

GAjax.CommandQueue.prototype.onerror = function() {
	alert("problem sending the data to the server");
}

GAjax.CommandQueue.prototype.repeat = function(freq) {
	this.unrepeat();
	
	if (freq > 0) {
		this.m_Freqency = freq;
		var cmd = "this.commandQueues[" + this.m_ID + "].fireRequest()";
		this.repeater = setInterval(cmd, freq * 1000);
	}
}

GAjax.CommandQueue.prototype.unrepeat = function() {
	if (this.repeater) {
		clearInterval(this.repeater);
	}
	this.repeater = null;
}

GAjax.CommandQueue.prototype.onLoad = function(loader) {
	//ФǡФƥ쥹ݥ󥹤֤
	//ФޥɤݻƤparseResponseؿƤӽФƤ
	for (var i = 0;i < this.m_SendCommand.length;i++) {
		this.m_SendCommand[i].parseResponse(loader);
	}
}
