<?php
/*
 * Created on 2006/06/29
 *
 */
 	
 	/**
 	 * Glover_Backup
 	 * Хåå׵ǽ󶡤륯饹
 	 */
	class Glover_Backup {
	
		/**
		 * makeBackup
		 * ꤵ줿ΥХååפ롣
		 * @param string $name ̾
		 * @return boolean	true
		 */
		function makeBackup($name) {
			//Хååפ롣ХååפɬҤȤĤεˤĤ
			//ҤȤĤΥХååץե뤬¸ߤ롣
			//Хååץե¤̥ե¸ߤ롣
			
			if (file_exists(BACKUPPATH.urlencode($name)."_backup.txt")) {
				//Хååץե뤬Ǥ¸ߤ硢ɲåХååפԤ
				
				$recode = $this->_getBackup($name);
				
				$count = count($recode) + 1;
				$tmp = array("time" => date("Y/n/d-H:i:s", filemtime(SCRIPTPATH.urlencode($name).".txt")), 
								"data" => implode("", file(SCRIPTPATH.urlencode($name).".txt")));
				array_push($recode, $tmp);
				
				//ߤΥХååץǡ¬롣
				$size = 0;
				foreach ($recode as $key => $data) {
					$size += strlen($data["data"]);
				}
				
				//iniեˡ³Хåå̤ꤹ롣ǥեȤǤ1MBȤʤäƤ롣
				if ($size >= getIniData('MaxBackupSize')) {
					//Хåå̤礭ä硢Ť򤫤顢̤ʤʤޤǺ³롣
					$tmp = $size;
					while ($tmp > getIniData('MaxBackupSize')) {
						$pop = array_pop($recode);
						$tmp -= strlen($pop['data']);
					}
				}
				
				//ꤷ顢Хååץե˥ե񤭽Ф
				$file = new GFile(BACKUPPATH.urlencode($name)."_backup.txt");
				$file->clear();
				$file->writeLine("---BACKUPHEADER---\n");
				foreach ($recode as $key => $data) {
					//񤭽Ф
					$file->writeLine($key." ".$data["time"]."\n");
				}
				$file->writeLine("---BACKUPHEADER---\n");
				foreach ($recode as $key => $data) {
					//ǡ񤭽Ф
					$file->writeLine("---".$key."---BEGIN\n");
					$file->writeLine($data["data"]);
					$file->writeLine("---".$key."---END\n");
				}
				$file->destroy();
				
				return true;
			} else {
				//Хååץե뤬¸ߤʤä硢ߤΥե뤫鹽롣
				$file = new GFile(BACKUPPATH.urlencode($name)."_backup.txt");
				$tmp = array("time" => date("Y/n/d-H:i:s", filemtime(SCRIPTPATH.urlencode($name).".txt")),
								"data" => implode("", file(SCRIPTPATH.urlencode($name).".txt")));

				$file->writeLine("---BACKUPHEADER---\n");
				$file->writeLine("1 ".$tmp["time"]."\n");
				$file->writeLine("---BACKUPHEADER---\n");
				$file->writeLine("---1---BEGIN\n");
				$file->writeLine($tmp["data"]."\n");
				$file->writeLine("---1---END\n");
				
				return true;
			}
		}
		
		/**
		 * readBackup
		 * Хååפ줿ե뤫ꤷɤ߽Ф
		 * @param string $name ɤ߽ФХååפ̾
		 * @param int $gen ɤ߽Ф
		 * @return array ɤ߽Ф줿Хåå
		 */
		function readBackup($name, $gen) {
			//ꤵ줿ɤ߽Фɤ߽Фϴñ
			$pat = preg_quote("---".$gen."---BEGIN\n", "/");
			$pat2 = preg_quote("---".$gen."---END\n","/");
			$file = new GFile(BACKUPPATH.urlencode($name)."_backup.txt");
			$all = $file->getAllLine();
			$ret = array();
			
			while (list($key, $val) = each($all)) {
				if (preg_match("/".$pat."/",$val)) {
					//ޥå硢ޤǲ
					while (list($key2, $val2) = each($all)) {
						if (preg_match($pat2, $val2)) {
							break;
						}
						$ret[] = $val2;
					}
					break;
				}
			}
			if (count($ret) == 0) {
				//Ԥ¸ߤʤ硢夬¸ߤʤȸ롣
				return null;
			}
			
			$file->destroy();
			return $ret;
		}
		
		/**
		 * deleteBackup
		 * ꤵ줿ΥХååפ顢ꤵ줿롣
		 * @param string $name ̾
		 * @param int $gen 
		 * @return boolean	true
		 */
		function deleteBackup($name, $gen) {
			//ꤵ줿롣줿ϡ٤ƾ˵ͤ롣
			//ޤټ롣
			$recode = $this->_getBackup($name);
			
			//ѤäȺƤޤ
			unset($recode[$gen]);
			
			//ϡ򹹿ʤХååץե˽񤭽ФƤ
			$file = new GFile(BACKUPPATH.$name."_backup.txt");
			$file->clear();
			$file->writeLine("---BACKUPHEADER---\n");
			foreach ($recode as $key => $data) {
				if (intval($key) >= $gen+1) {
					$file->writeLine(($key-1)." ".$data["time"]."\n");
				} else {
					$file->writeLine($key." ".$data["time"]."\n");
				}
			}
			$file->writeLine("---BACKUPHEADER---\n");
			
			foreach ($recode as $key => $data) {
				//ǡ񤭽Ф
				$line = explode("\n", $data["data"]);
				if (intval($key) >= $gen + 1) {
					$key--;
				}
				$file->writeLine("---".$key."---BEGIN\n");
				foreach ($line as $l) {
					$file->writeLine($l."\n");
				}
				$file->writeLine("---".$key."---END\n");
			}
			$file->destroy();
		}
		
		/**
		 * restoreBackup
		 * Хååפ鵭롣
		 * @param string $name 뵭̾
		 * @param string $gen 
		 * @return boolean true
		 */
		function restoreBackup($name, $gen) {
			//$genꤨʤꤵƤ硢false֤
			$backup = $this->readBackup($name, $gen);
			if ($backup === null) {
				return false;
			}
			
			$file = new Glover_ContentFile;
			if (!$file->writeContent($name, implode("", $backup))) {
				return false;
			}
			
			return true;
			
		}
		
		/**
		 * getRecode
		 * θ¸ߤιʤɤ롣
		 * @param string $name 뵭̾
		 * @return array =>ȤʤäƤ
		 */
		function getRecode($name) {
			//ˡϴñ
			$file = $this->_getBackup($name);
			
			$ret = array();
			foreach ($file as $key => $data) {
				$ret[$key] = $data["time"];
			}
			
			return $ret;
		}
		
		/**
		 * _getBackup
		 * ꤵ줿ХååץեȤȤ֤
		 * @param string $name ̾
		 * @return array ǡä
		 */
		function _getBackup($name) {
			//ΥХååפ¸ߤʤϡnull֤Ƥ롣
			if(!file_exists(BACKUPPATH.urlencode($name)."_backup.txt")) {
				return null;
			}
			
			$file = new GFile(BACKUPPATH.urlencode($name)."_backup.txt");
			$line = $file->getAllLine();
			
			$ret = array();
			$innerheader = 0;
			$count = 0;
			while (list($key,$val) = each($line)) {
				
				if ($val == "---BACKUPHEADER---\n") {
					if ($innerheader == 0) {
						$innerheader = 1;
						continue;
					} elseif ($innerheader == 1) {
						$innerheader = 2;
					}
				}
				
				if ($innerheader == 1) {
					preg_match("/(.+?) (.+)\n/", $val, $match);
					$ret[intval($match[1])]["time"] = $match[2];
					unset($match);
				} elseif ($innerheader == 2) {
					//ǡΥإåõ
					if (preg_match("/\-\-\-([0-9])\-\-\-BEGIN/", $val, $match)) {
						$count = intval($match[1]);
						$innerheader = 3;
						$ret[$count]["data"] = "";
					}
				} elseif ($innerheader == 3) {
					//ǡʤмơǡǤʤ롣
					if (preg_match("/\-\-\-$count\-\-\-END/", $val)) {
						$count = 0;
						$innerheader = 2;
						
						continue;
					} else {
						$ret[$count]["data"] .= $val;
					}
				}
				
			}
			return $ret;
		}
	
	}
?>
