<?php

	class gglib {
		
		var $IsOpenFile;
		var $FileName;
		var $FileHandle;
		
		//
		//	gglib($fname)
		//	proc  : 󥹥ȥ饯ե̾Ϥ줿ϤΥե򳫤
		//	@argv1: ե̾
		//	out   : 1ʤäundef
		//
		function gglib($fname = "") {
			//ե̾褿ե򳫤
			//ʤϲ⤷ʤ
			//ޤե򳫤Ȥ˼Ԥ硢ʤǽ
			//ޤʤǤɤ߽ФԤΤȤ롣
			
			//ȤߤGFile饹ͤǤϡХʥǤλѤϽʤ
			//GFile饹ϡޤʸä˰ʸò饹Ǥꡢ
			//ʾǤ⤽ʲǤʤǤ롣
			//ޤʤΤǡ졹flockԤȤˤ롣
			if ($fname == "") {
				
				if ($fname == "") {
					$this->IsOpenFile = false;
					$this->FileName = "";
					$this->FileHandle = "";
				} else {
					if (!$this->FileHandle = fopen($fname,"rb"))
						return;
					if (flock($this->FileHandle,LOCK_SH) === false)
						return;
					$this->IsOpenFile = true;
					$this->FileName = $fname;
				}
				
			} else {
				$this->IsOpenFile = false;
				$this->FileName = "";
				$this->FileHandle = "";
			}
		}
		
		//
		//	destroy()
		//	proc  : Ƥ륤᡼եĤƤ롣
		//	out   : ʤ
		//
		function destroy() {
			$this->release();
		}
		
		//
		//	innerOpen($fname,$mode)
		//	proc  : ե򳫤
		//	@argv1: ե̾
		//	@argv2: ⡼
		//	out   : trueʤäfalse
		//
		function innerOpen($fname,$mode) {
			
			if ($fname == "" || $mode == "") {
				return false;
			}
			
			//ĤƤ
			$this->release();
			
			if (!$this->FileHandle = fopen($fname,$mode)) {
				return false;
			}
			
			if (flock($this->FileHandle,LOCK_SH) === false) {
				return false;
			}
			
			$this->setOpenFileName($fname);
			$this->setOpenFile(true);
			
			return true;
		}
		
		//
		//	release()
		//	proc  : ߳ƤեĤ롣
		//	out   : ʤ
		//
		function release() {
			//ǻѤ롣
			
			//Ǥ˳ƤСĤ
			if ($this->isOpenFile()) {
				flock($this->getHandle(),LOCK_UN);
				fclose($this->getHandle());
			}
			$this->setOpenFileName("");
			$this->setOpenFile(false);
		}
		
		//
		//	getOpenFileName()
		//	proc  : ߳Ƥե֤̾
		//	out   : ߳Ƥե̾
		//
		function getOpenFileName() {
			return $this->FileName;
		}
		
		//
		//	setOpenFileName($fname)
		//	proc  : ߳Ƥե̾ѹ
		//	@argv1: ꤹե̾
		//	out   : ʤ
		//
		function setOpenFileName($fname) {
			$this->FileName = $fname;
		}
		
		//
		//	isOpenFile()
		//	proc  : ե뤬Ƥ뤫ɤ
		//	out   : 1or0
		//
		function isOpenFile() {

			return $this->IsOpenFile;
		}
		
		//
		//	setOpenFile($flg)
		//	proc  : ե뤬Ƥ뤫ɤΥե饰
		//	@argv1: ե饰
		//	out   : ʤ
		//
		function setOpenFile($flg) {

			$this->IsOpenFile = $flg;
		}
		
		//
		//	getHandle()
		//	proc  : ߳Ƥե֤̾
		//	out   : ߳Ƥե̾
		//
		function getHandle() {

			return $this->FileHandle;
		}
		
		//##########################################################
		
		//
		//	getImageSize($filename)
		//	proc  : ꤷեνĲ֤
		//			Ϥʤ硢ߥե뤬Ƥʤ顢
		//			ΥեΥƤ롣
		//			ޤե뤬ƤꡢĥѥϤ줿硢
		//			Ǥ˳ƤեĤϤ줿ѥǳľ
		//	@argv1: ᡼եΥѥ
		//	out   : 'width''height'ȤΥϥå塣Իˤ̤
		//
		function getImageSize($filename) {
			$data = array();
			
			if ($filename != "") {
				preg_match("/\.(.+)$/",$filename,$suf);
				
				//줾˳꿶
				switch ($suf[1]) {
					case "":
						return false;
					case "gif":
					case "GIF":
						$data = $this->getImageSize_gif($filename);
						break;
					case "png":
					case "PNG":
						$data = $this->getImageSize_png($filename);
						break;
					case "jpg":
					case "jpeg":
					case "JPG":
						$data = $this->getImageSize_jpg($filename);
						break;
					case "bmp":
					case "BMP":
						$data = $this->getImageSize_bmp($filename);
						break;
					default:
						break;
				}
			} elseif ($this->getOpenFileName() == "") {
				//ɤäξ硢äȴ롣
				return false;
			} else {
				//ե뤬Ǥ˳Ƥ硢̵ǸƤӽФФ褤
				preg_match("/\.(.+)$/",$this->getOpenFileName(),$suf);
				
				//줾˳꿶
				switch ($suf[1]) {
					case "":
						return false;
					case "gif":
					case "GIF":
						$data = $this->getImageSize_gif();
						break;
					case "png":
					case "PNG":
						$data = $this->getImageSize_png();
						break;
					case "jpg":
					case "jpeg":
					case "JPG":
						$data = $this->getImageSize_jpg();
						break;
					case "bmp":
					case "BMP":
						$data = $this->getImageSize_bmp();
						break;
					default:
						break;
				}
			}
			
			return $data;
		}
		
		//
		//	getImageSize_jpg($filename)
		//	proc  : ꤷեνĲ֤(jpgե)
		//	@argv1: ᡼եΥѥ
		//	out   : 'width''height'ȤΥϥå塣Իˤ̤
		//
		function getImageSize_jpg($filename = "") {
			$data = array();
			$buffer = "";
			$readsize = 0;
			$size = 0;

			if ($filename != "") {
				if (!$this->innerOpen($filename,"rb")) {
					return false;
				}
				
				//FFC0ޡޤĤ롣
				//եƬõƤƬˤ
				//SOI ȥޡFF D8 Ƚ롢EOI ȥޡ FF D9
				//Τǡ̵뤹롣
				fseek($this->getHandle(),2);
				while (true) {
					//ե뽪λޤǰ롣
					//ХȤɤ߽ФĴ٤Ƥ
					$buffer = fread($this->getHandle(),1);
					if (strlen($buffer) == 0)
						break;
					
					$buffer = unpack("Cbuf",$buffer);
					if ($buffer['buf'] == 0xFF) {
						//ޡȯΣХȤƤ롣
						$buffer = fread($this->getHandle(),1);
						$buffer = unpack("Cbuf",$buffer);
						
						if ($buffer['buf'] == 0xC0) {
							//ޡȯХȤseekФ
							if (fseek($this->getHandle(),3,SEEK_CUR) == -1)
								break;
							
							//ǡͥХȰ쵤ɤ߽Ф
							$size = fread($this->getHandle(),4);
							if (strlen($size) == 0)
								break;
							
							//2ХȤ(ĤޤShort)ȤʤäƤΤǡ
							//vunpackƤФ褤
							$dat = unpack("n2size",$size);
							$data['width'] = $dat['size1'];
							$data['height'] = $dat['size2'];
							
							//Ǥ顢last롣
							break;
						} elseif ($buffer == 0x00) {
							//ξ硢ǡǤ롣
							continue;
						} else {
							//ʳξ硢ΣХȤơ
							//ʬʤ
							$buffer = fread($this->getHandle(),2);
							$buffer = unpack("nlittle",$buffer);
							fseek($this->getHandle(),$buffer['little']-2,SEEK_CUR);
						}
					}
					unset($buffer);
				}
			} elseif ($this->isOpenFile() === true) {
				//ե̾ʤ硣ˤʤʡ
				//FFC0ޡޤĤ롣
				//եƬõƤƬˤ
				//SOI ȥޡFF D8 Ƚ롢EOI ȥޡ FF D9
				//Τǡ̵뤹롣
				fseek($this->getHandle(),2);
				while (true) {
					//ե뽪λޤǰ롣
					//ХȤɤ߽ФĴ٤Ƥ
					$buffer = fread($this->getHandle(),1);
					if (strlen($buffer) == 0)
						break;
					
					$buffer = unpack("Cbuf",$buffer);
					if ($buffer['buf'] == 0xFF) {
						//ޡȯΣХȤƤ롣
						$buffer = fread($this->getHandle(),1);
						$buffer = unpack("Cbuf",$buffer);
						
						if ($buffer['buf'] == 0xC0) {
							//ޡȯХȤseekФ
							if (fseek($this->getHandle(),3,SEEK_CUR) == -1)
								break;
							//ǡͥХȰ쵤ɤ߽Ф
							$size = fread($this->getHandle(),4);
							if (strlen($size) == 0)
								break;
							
							//2ХȤ(ĤޤShort)ȤʤäƤΤǡ
							//vunpackƤФ褤
							$dat = unpack("n2size",$size);
							$data['width'] = $dat['size1'];
							$data['height'] = $dat['size2'];
							
							//Ǥ顢last롣
							break;
						} elseif ($buffer == 0x00) {
							//ξ硢ǡǤ롣
							continue;
						} else {
							//ʳξ硢ΣХȤơ
							//ʬʤ
							$buffer = fread($this->getHandle(),2);
							$buffer = unpack("nlittle",$buffer);
							fseek($this->getHandle(),$buffer['little']-2,SEEK_CUR);
						}
					}
					unset($buffer);
				}
			} else {
				return false;
			}
			
			//ƬᤷƤȤ褦
			fseek($this->getHandle(),0,0);
			
			return $data;
		}
		
		//
		//	getImageSize_gif($filename)
		//	proc  : ꤷեνĲ֤(gifե)
		//	@argv1: ᡼եΥѥ
		//	out   : 'width''height'ȤΥϥå塣Իˤ̤
		//
		function getImageSize_gif($filename = "") {
			$data = array();
			$readsize = 0;
			$size = 0;
			
			//GIFեξ硢ʤꥷץ롣
			//ƬΥեå62ХȤ82˹⤵
			//äƤ褦ʤΤǡեåȤ6ХȤ˥åȤơ
			//4ХɤߤunpackФ褤
			//ʤǥϴĶ¸ޤȥ륨ǥ
			//ʤȤϻפ
			
			if ($filename =! "") {
				//ե̾ϤƤ
				if (!$this->innerOpen($filename,"rb")) {
					return false;
				}
				
				fseek($this->getHandle(),6);
				$size = fread($this->getHandle(),4);
				$array = unpack("v2size",$size);
				$data['width'] = $array['size1'];
				$data['height'] = $array['size2'];
			} elseif ($this->isOpenFile()) {
				//ϤƤʤƤ
				fseek($this->getHandle(),6);
				$size = fread($this->getHandle(),4);
				$array = unpack("v2size",$size);
				$data['width'] = $array['size1'];
				$data['height'] = $array['size2'];
			} else {
				return false;
			}
			fseek($this->getHandle(),0);
			
			return $data;
		}
		
		//
		//	getImageSize_png($filename)
		//	proc  : ꤷեνĲ֤(pngե)
		//	@argv1: ᡼եΥѥ
		//	out   : 'width''height'ȤΥϥå塣Իˤ̤
		//
		function getImageSize_png($filename = "") {
			$data = array();
			$readsize = 0;
			$size = 0;
			
			//pngեξGIFƱͤˡ
			//ʤꥷץ롣
			//եå16longեå20longǹ⤵äƤ
			if ($filename != "") {
				//ե̾ϤƤ
				if (!$this->innerOpen($filename,"rb")) {
					return false;
				}
				
				fseek($this->getHandle(),16);
				$size = fread($this->getHandle(),8);
				$array = unpack("N2size",$size);
				$data['width'] = $array['size1'];
				$data['height'] = $array['size2'];
			} elseif ($this->isOpenFile()) {
				//ϤƤʤե뤬Ƥ
				fseek($this->getHandle(),16);
				$size = fread($this->getHandle(),8);
				$array = unpack("N2size",$size);
				$data['width'] = $array['size1'];
				$data['height'] = $array['size2'];
			} else {
				return false;
			}
			fseek($this->getHandle(),0);
			
			return $data;
		}
		
		//
		//	getImageSize_bmp($filename)
		//	proc  : ꤷեνĲ֤(bmpե)
		//	@argv1: ᡼եΥѥ
		//	out   : 'width''height'ȤΥϥå塣Իˤ̤
		//
		function getImageSize_bmp($filename = "") {
			$data = array();
			$readsize = 0;
			$size = 0;
			//ӥåȥޥåץեξGIFPNGƱͤ
			//ץ
			//եå18longեå22longǹ⤵äƤ
			
			if ($filename != "") {
				//ե̾ϤƤ
				if (!$this->innerOpen($filename,"rb")) {
					return false;
				}
				
				fseek($this->getHandle(),16);
				$size = fread($this->getHandle(),8);
				$array = unpack("V2size",$size);
				$data['width'] = $array['size1'];
				$data['height'] = $array['size2'];
			} elseif ($this->isOpenFile()) {
				//ϤƤʤե뤬Ƥ
				fseek($this->getHandle(),16);
				$size = fread($this->getHandle(),8);
				$array = unpack("V2size",$size);
				$data['width'] = $array['size1'];
				$data['height'] = $array['size2'];
			} else {
				return false;
			}
			fseek($this->getHandle(),0);
			
			return $data;
		}
	}

?>