<?php
	//Glover夫CGIԤ
	//ͤϡdefine
	
	/**
	 * register_cgi_navigator
	 * CGIʥӥƤӽФ褦ˤ
	 * @param void
	 * @return void
	 */
	function cgi_RegistreNavigator() {
		return array("regist_name" => "CGI");
	}
	
	/**
	 * cgi_InlinePlugin
	 * ץ饰ؤΥ󥯤ȤִԤ
	 * @param void
	 * @return void
	 */
	function cgi_InlinePlugin() {
		//&cgi(<CGI̾ĥҤϤʤƤ褤>,<ƤӽФ>(,<󥯤̾>));
		//ȤΰȤ롣
		
		$args = array(getArgv("cgi_1"), getArgv("cgi_2"));
		//ե뤬¸ߤƤơʤĳĥҤphpޤcgiǤΤߡ
		
		if (!file_exists(PLUGINPATH."cgi/".$args[0]) || !preg_match("/\.(cgi|php)$/",$args[0])) {
			setSendData("cgi", REPLACE, "");
			return false;
		}
		
		switch ($args[1]) {
			case 'a':
				//̾󥯡<a>ǤѤ롣
				//Ǹΰʤ硢ꤵ줿̾ǺƤ롣
				if (getArgc() == 2) {
					$return = "<a href=\"".PLUGINPATH."cgi/".$args[0]."\">".$args[0]."</a>";
				} elseif (getArgc() == 3) {
					$return = "<a href=\"".PLUGINPATH."cgi/".$args[0]."\">".$args[2]."</a>";
				}
				break;
			case 'i':
				//imgѤ롣󥿡ϤʤɤǻѤ롣
				$return = "<img src=\"".PLUGINPATH."cgi/".$args[0]."\"></img>";
				break;
		}
		
		setSendData("cgi", REPLACE, $return);
		
		return true;
	}
	
	/**
	 * cgi_ActionPlugin
	 * ץ饰Ԥ
	 * @param void
	 * @return void
	 */
	function cgi_ActionPlugin() {
		
		$returnvalue = array();
		$cgi = new Plugin_CGI;
		switch (getArgv("act")) {
			case "create":
				//ǥ쥯ȥ깽ҲϽ
				$cgi->makeDirListToText();
				$returnvalue['page'] = $cgi->dispCGIForm();
				break;
			case "dir":
				//ǥ쥯ȥؤνء
				$returnvalue['page'] = $cgi->dispDirOperateForm();
				break;
			case "file":
				//ե
				$returnvalue['page'] = $cgi->dispFileOperateForm();
				break;
			case "upload":
				//ե륢åץɽ
				$cgi->uploadFileToDir();
				$returnvalue['page'] = $cgi->dispDirOperateForm();
				break;
			case "deldir";
				//ǥ쥯ȥ
				$cgi->deleteDirectory();
				$returnvalue['page'] = $cgi->dispCGIForm();
				break;
			case "delfile":
				//ե
				$cgi->deleteFile();
				$returnvalue['page'] = $cgi->dispDirOperateForm();
				break;
			case "update":
				//ե빹
				$cgi->updateFile();
				$returnvalue['page'] = $cgi->dispFileOperateForm();
				break;
			case "chmod":
				//եѡߥåѹ롣
				$cgi->changePerFile();
				$returnvalue['page'] = $cgi->dispFileOperateForm();
				break;
			default:
				$returnvalue['page'] = $cgi->dispCGIForm();
				break;
		}
		
		return $returnvalue;
	}
	
	/**
	 * Plugin_CGI
	 * CGIԤץ饰
	 * @since PHP4.0
	 * @author derui
	 * @package Glover
	 */
	class Plugin_CGI {
		
		//runȤ鷺͡ॹڡξͤ򤹤ΤŪǤΤǡ
		//줾ΥåѡԤ
		
		/**
		 * _initialize
		 * ǽˤΥץ饰󤬼¹Ԥ줿Ȥ˼¹Ԥ롣
		 * @param void
		 * @access private
		 * @return void
		 */
		function _initialize() {
			
			if (!file_exists(PLUGINPATH."cgi")) {
				//ǥ쥯ȥ꤬ʤ硢롣
				mkdir(PLUGINPATH."cgi",0777);
			}
		}
		
		/**
		 * dispCGIForm
		 * CGIܥեɽ롣
		 * @param void
		 * @access public
		 * @return void
		 */
		function dispCGIForm() {
			//ܴ̤Ǥϡǥ쥯ȥ깽ҥƥȥꥢΤߤ¸ߡ
			$this->_initialize();
			
			$return = getInnerHeader();
			$return .= getNavigator();
			//ĥ꡼ɽ
			$return .= "<div id=\"pagestyle\">\n";
			$return .=  "<div id=\"centerbox\">\n";
			$return .= "<div id=\"menu\">\n<div id=\"mainmenu\">\n";
			$return .= $this->_makeDirTree();
			$return .= "</div>\n</div>\n";
			//Խɽ
			$return .= "<div id=\"main\">\n<div id=\"content\">\n";
			$return .= $this->_makeListEditArea();
			$return .= "</div>\n</div>\n</div>\n</div>\n";
			$return .= getInnerHooter();
			
			return $return;
		}
		
		/**
		 * _makeDirTree
		 * ǥ쥯ȥĥ꡼ɽ
		 * @param string $dir ǥեͤ/Ȥʤǥ쥯ȥꤹ롣
		 * @return void
		 */
		function _makeDirTree($dir = "/") {
			//ǥ쥯ȥĥ꡼롣
			
			if ($dir == "/" || !is_dir(PLUGINPATH."cgi/".$dir)) {
				//¸ߤʤǥ쥯ȥ꤬Ϥ줿硢ǥեȤ롣
				
				$return .= "<img src=\"".IMAGEPATH."win_close.png\">CGI<br/>\n";
							
				$directory = array();
				if ($hd = opendir(PLUGINPATH."cgi/$dir")) {
					while (($read = readdir($hd)) !== false) {
						if ($read != '.' && $read != "..") {
							if (is_dir(PLUGINPATH."cgi/$dir".$read)) {
								//ǥ쥯ȥξ
								array_push($directory,$read);
							}
						}
					}
					closedir($hd);
				}
				
				if (count($directory) == 0) {
					$return .= "<img src=\"".IMAGEPATH."line2.png\"><img src=\"".IMAGEPATH."win_close.png\">
							<a href=\"".$GLOBALS['ActionModuleName']."plugin=cgi\">롼</a><br/>\n";
				} else {
					$return .= "<img src=\"".IMAGEPATH."line1.png\"><img src=\"".IMAGEPATH."win_close.png\">
							<a href=\"".$GLOBALS['ActionModuleName']."plugin=cgi\">롼</a><br/>\n";
				}
				
				if (count($directory) > 0) {
					
					$tmp = array_pop($directory);
					foreach ($directory as $t) {
						$return .= "<img src=\"".IMAGEPATH."line1.png\"><img src=\"".IMAGEPATH."win_close.png\">
								<a href=\"".$GLOBALS['ActionModuleName']."plugin=cgi&act=dir&dir=$t\">$t</a><br/>\n";
					}
					$return .= "<img src=\"".IMAGEPATH."line2.png\"><img src=\"".IMAGEPATH."win_close.png\">
								<a href=\"".$GLOBALS['ActionModuleName']."plugin=cgi&act=dir&dir=$tmp\">$tmp</a><br/>\n";
				}
			} else {
				//ǥեȤʤ硣ϡΥǥ쥯ȥγع¤ŸƤ롣
				$return .= "<img src=\"".IMAGEPATH."win_close.png\">CGI<br/>\n";
				$return .= "<img src=\"".IMAGEPATH."line1.png\"><img src=\"".IMAGEPATH."win_close.png\">
							<a href=\"".$GLOBALS['ActionModuleName']."plugin=cgi\">롼</a><br/>\n";
				$return .= "<img src=\"".IMAGEPATH."line2.png\"><img src=\"".IMAGEPATH."win_close.png\">
							<span style=\"font-weight:bold\">$dir</span><br/>\n";
				
				
				$files = array();
				if ($hd = opendir(PLUGINPATH."cgi/".$dir)) {
					while (($read = readdir($hd)) !== false) {
						if ($read != '.' && $read != "..") {
							array_push($files,$read);
						}
					}
					closedir($hd);
				}
				
				if (count($files) > 0) {
					$tmp = array_pop($files);
					foreach ($files as $t) {
						if (is_dir(PLUGINPATH."cgi/".$dir."/$t")) {
							//ǥ쥯ȥǤä硣
							$return .= "<img src=\"".IMAGEPATH."line3.png\"><img src=\"".IMAGEPATH."line1.png\">
									<img src=\"".IMAGEPATH."win_close.png\">
									<a href=\"".$GLOBALS['ActionModuleName']."plugin=cgi&act=dir&dir=$dir/$t\">$t</a><br/>\n";
						} else {
							$return .= "<img src=\"".IMAGEPATH."line3.png\"><img src=\"".IMAGEPATH."line1.png\">
									<img src=\"".IMAGEPATH."file.png\">
									<a href=\"".$GLOBALS['ActionModuleName']."plugin=cgi&act=file&file=$dir/$t&dir=$dir\">$t</a><br/>\n";
						}
					}
					
					if (is_dir(PLUGINPATH."cgi/".$dir."/$tmp")) {
						$return .= "<img src=\"".IMAGEPATH."line3.png\"><img src=\"".IMAGEPATH."line2.png\">
									<img src=\"".IMAGEPATH."win_close.png\">
									<a href=\"".$GLOBALS['ActionModuleName']."plugin=cgi&act=dir&dir=$dir/$tmp\">$tmp</a><br/>\n";
					} else {
						$return .= "<img src=\"".IMAGEPATH."line3.png\"><img src=\"".IMAGEPATH."line2.png\">
									<img src=\"".IMAGEPATH."win_close.png\">
									<a href=\"".$GLOBALS['ActionModuleName']."plugin=cgi&act=file&file=$dir/$tmp&dir=$dir\">$tmp</a><br/>\n";
					}
				}
			}
			
			return $return;
		}
		
		/**
		 * _makeListEditArea
		 * ǥ쥯ȥ깽ҥƥȥꥢ
		 * @param void
		 * @access private
		 * @return void
		 */
		function _makeListEditArea() {
			global $ActionModuleName;
			global $FormAuthInfo;
			$return = <<<AREA
<form method="post" action="$ActionModuleName">
<div style="border:1px solid #a9a9a9;padding:1px;">
ǥ쥯ȥ깽򵭽Ҥޤ<br/>
ˡϡcgi.plugin.phpźդƤcgi.html<br/>
<textarea name="list" rows="3" cols="60"></textarea><br/>
<input type="submit" value=""/>
<input type="hidden" name="plugin" value="cgi"/>
<input type="hidden" name="act" value="create"/>
$FormAuthInfo
</div>
</form>
AREA;
			return $return;
		}
		
		/**
		 * makeDirListToText
		 * ƥȥꥢ˵Ҥ줿ƥȤ顢ǥ쥯ȥꥹȤ롣
		 * @param void
		 * @access public
		 * @return void
		 */
		function makeDirListToText() {
			//ޤϥƥȥǡβ
			$data = $GLOBALS['RequestData']['list'];
			
			//Ѷػߤʸ
			//ѶػʸϡȾѥڡ/.ʸʤ
			$data = preg_replace("/[\t|\r|\/|\.| ]/","",$data);
			$list = preg_split("/(\r\n|\n)/",$data);
			if (($tmp = array_pop($list)) != "") array_push($list,$tmp);
			
			//ꥹȲϤ򳫻ϡ
			$tmp = array_shift($list);
			if (preg_match("/^\-/",$tmp)) {
				//Ǥä硢⤦Ͻλ
				return;
			}
			
			$dirlist = array();
			if (count($list) > 0) {
			
				$dirlevel = array();
				$flg = array('root' => false, 1 => false);
				$dirname = "";
				
				foreach ($list as $line) {
					if (preg_match("/^(\-+)(.+)$/",$line,$match)) {
						//ϥޥåʤФʤʤ
						//줬ޥåʤϡ̵뤹롣
						if ($match[1] == '-') {
							//Ǥ硢ơե饰ΩƤƤ
							if ($flg['root'] === false) {
								//ǥ쥯ȥ٥ꥹȤǤʤ硣
								//ե饰ˤơ٥ꥹȤΥǥ쥯ȥ̾ݴɤ
								$flg['root'] = true;
								$flg[1] = true;
								$dirname = $match[2];
								$dirlevel = array(1 => array($match[2]));
							} else {
								//ξ硢dirlistˡݤƤ
								//ơ¾Ǥ롣
								array_unshift($dirlevel, $dirname);
								array_push($dirlist,$dirlevel);
								$dirname = $match[2];
								$dirlevel = array(1 => array($match[2]));
								$flg = array('root' => true, 1 => true);
							}
						} else {
							
							if ($flg[strlen($match[1])-1] == true) {
								//ľΥǥ쥯ȥ꤬¸ߤ硢礹롣
								//λľΥǥ쥯ȥ꤬ʣ¸ߤ礬롣
								//ΤȤˤϡľΥǥ쥯ȥǥ쥯ȥȷ礹롣
								if ($flg[strlen($match[1])] == false) {
									//ǽΰĤä硣
									$dirlevel[strlen($match[1])] = array($dirlevel[strlen($match[1]) - 1][count($dirlevel[strlen($match[1]) - 1]) - 1]."/".$match[2]);
								} else {
									//ǽǤϤʤä硣
									array_push($dirlevel[strlen($match[1])],$dirlevel[strlen($match[1]) - 1][count($dirlevel[strlen($match[1]) - 1]) - 1]."/".$match[2]);
								}
							}
							//¸ߤʤäϡ̵뤹롣
						}
						unset($match);
					} else {
						//λν˴롣
						$dirlist = array();
					}
				}
				//νȴȤflgtrueʤ顢֤Ǥ
				if ($flg['root'] === true) {
					array_unshift($dirlevel,$dirname);
					array_push($dirlist,$dirlevel);
				}
			}
			
			if (!file_exists("cgi/".$tmp)) {
				mkdir(PLUGINPATH."cgi/".$tmp,0777);
			}
			
			if (count($dirlist) > 0) {
				foreach ($dirlist as $list) {
					//$listϡޤǤ롣
					$first = array_shift($list);
					if (!file_exists("cgi/$tmp".$first)) {
						mkdir(PLUGINPATH."cgi/$tmp/".$first, 0777);
					}
					array_shift($list);
					if (count($list) > 0) {
						foreach ($list as $inner) {
							//ǥ쥯ȥϸ§Ȥ0777Ǻ롣
							foreach ($inner as $dir) {
								if (!file_exists(PLUGINPATH."cgi/$tmp/".$dir)) {
									mkdir(PLUGINPATH."cgi/$tmp/".$dir, 0777);
								}
							}
						}
					}
				}
			}
			
			return true;
		}
		
		/**
		 * dispDirOperateForm
		 * ǥ쥯ȥեϤ롣
		 * @param void
		 * @access public
		 * @return string եޤࡢڡΤɽHTML
		 */
		function dispDirOperateForm() {
			//ۤȤdispCGIFormƱ
			$value = getValues();
			$return = getInnerHeader();
			$return .= getNavigator();
			//ĥ꡼ɽ
			$return .= "<div id=\"pagestyle\">\n";
			$return .=  "<div id=\"centerbox\">\n";
			$return .= "<div id=\"menu\">\n<div id=\"mainmenu\">\n";
			$return .= $this->_makeDirTree($value["dir"]);
			$return .= "</div>\n</div>\n";
			//Խɽ
			$return .= "<div id=\"main\">\n<div id=\"content\">\n";
			$return .= $this->_makeDirEditArea();
			$return .= "</div>\n</div>\n</div>\n</div>\n";
			
			return $return;
		}
		
		/**
		 * _makeDirEditArea
		 * ǥ쥯ȥեμΤɽ롣
		 * @param void
		 * @return string եɽHTML
		 */
		function _makeDirEditArea() {
			//åץɥեࡢǥ쥯ȥեĤˤΡ
			global $ActionModuleName;
			global $FormAuthInfo;
			
			$value = getValues();
			$dir = $value['dir'];
			$tmp = "";
			for ($i = 1;$i <= 5;$i++) {
				$tmp .= "åץ$i<input type=\"file\" name=\"upload_file[]\"/><br/>\n";
			}
			
			$return = <<<AREA
<form method="post" action="$ActionModuleName" enctype="multipart/form-data">
<div style="border:1px solid #a9a9a9;padding:1px;">
٤5ĤޤǥåץɤǤޤ<br/>
åץɤ줿եϡΥǥ쥯ȥޤ<br/>
<input type="hidden" name="MAX_FILE_SIZE" value="1048576"/>
$tmp
<br/>
<input type="submit" value="åץ"/>
<input type="hidden" name="plugin" value="cgi"/>
<input type="hidden" name="act" value="upload"/>
<input type="hidden" name="dir" value="$dir"/>
$FormAuthInfo
</div>
</form>
<form method="post" action="$ActionModuleName">
<div style="border:1px solid #a9a9a9;padding:1px;">
֥ǥ쥯ȥץܥ򲡤ȡǥ쥯ȥƤΥեڤӥǥ쥯ȥ꤬졢<br/>
ǥ쥯ȥǤޤ<br/>
ΤϡǤޤΤǤդ<br/>
<br/>
<input type="submit" value="ǥ쥯ȥ"/>
<input type="hidden" name="plugin" value="cgi"/>
<input type="hidden" name="act" value="deldir"/>
<input type="hidden" name="dir" value="$dir"/>
$FormAuthInfo
</div>
</form>
AREA;
			return $return;
		}
		
		/**
		 * uploadFileToDir
		 * ե륢åץɽԤ
		 * @param void
		 * @return void
		 */
		function uploadFileToDir() {
			//ޤġ줾ľ
			$mg = new ManageGlobal;
			
			$files = $mg->GetFile('upload_file');
			$names = $files['name'];
			$tmpnames = $files['tmp_name'];
			
			$dir = getRequest("dir");
			//ܸե̾ϥᡢȤ뤬ɤ褦ʤ⤹
			foreach ($names as $key => $val) {
				if ($tmpnames[$key] != "") {
					move_uploaded_file($tmpnames[$key], PLUGINPATH."cgi/$dir/".$val);
				}
			}
		}
		
		/**
		 * deleteDirectory
		 * ǥ쥯ȥ롣
		 * @param void
		 * @return void
		 */
		function deleteDirectory() {
			
			$dirlist = getFileListtoDir(PLUGINPATH."cgi/".getRequest("dir"));
			
			foreach ($dirlist as $key => $dir) {
				foreach ($dir as $file) {
					if (file_exists($key."/$file")) {
						unlink($key."/$file");
					}
				}
				rmdir($key);
			}
			
			//Ǹˡ־ۤ롣
			//rmdir(PLUGINPATH."cgi/".getRequest("dir"));
		}
		
		/**
		 * dispFileOperateForm
		 * եԽեϤ롣
		 * @param void
		 * @access public
		 * @return void
		 */
		function dispFileOperateForm() {
		
			$return = printInnerHeader();
			$return .= printNavigator();
			//ĥ꡼ɽ
			$return .= "<div id=\"pagestyle\">\n";
			$return .=  "<div id=\"centerbox\">\n";
			$return .= "<div id=\"menu\">\n<div id=\"mainmenu\">\n";
			$return .= $this->_makeDirTree(getRequest("dir"));
			$return .= "</div>\n</div>\n";
			//Խɽ
			$return .= "<div id=\"main\">\n<div id=\"content\">\n";
			$return .= $this->_makeFileEditArea();
			$return .= "</div>\n</div>\n</div>\n</div>\n";
			
			return $return;
		}
		
		/**
		 * _makeFileEditArea
		 * եԽΰɽ롣
		 * @param void
		 * @return void
		 */
		function _makeFileEditArea() {
			global $ActionModuleName;
			global $FormAuthInfo;
			
			$file = getRequest("file");
			$dir = getRequest("dir");

			//ƥȥեƤϡŪEUC-JPѴ롣̵Ѥˡ
			//եξϡĤ̤target󥯤ŽäƤ롣
			if (preg_match("/\.(txt|pl|pm|cgi|php)$/",$file)) {
				$f = new GFile(PLUGINPATH."cgi/".$file);
				$tmp = implode("", $f->getAllLine());
				$encode = "";
				if ($GLOBALS['Use_mbstring'] == true) {
					$encode = mb_detect_encoding($tmp, "UTF-8,EUC-JP,SJIS");
					$tmp = mb_convert_encoding($tmp, "EUC-JP", $encode);
				} else {
					switch (AutoDetect($tmp)) {
						//¿٤ʤ
						case 1:
							$encode = "EUC-JP";
							break;
						case 2:
							$encode = "SJIS";
							break;
						case 4:
							$encode = "UTF-8";
							break;
					}
					
					$tmp = JcodeConvert($tmp, AutoDetect($tmp), 1);
					
				}
				$tmp = htmlspecialchars($tmp);
				$form = "<textarea name=\"editdata\" rows=\"20\" cols=\"60\">$tmp</textarea>\n<br/><br/>
						<input type=\"submit\" value=\"\"/>";
				$f->destroy();
			} elseif (preg_match("/\.(jpg|JPG|bmp|BMP|png|PNG|gif|GIF)$/",$file)) {
				//եξ硣
				$form = "<a href=\"".PLUGINPATH."cgi/$file\" target=\"blank\">ץӥ塼</a><br/>";
			}
			
			$stat = stat(PLUGINPATH."cgi/".$file);
			$per = $stat[2];
			
			$return = <<<AREA
<form method="post" action="$ActionModuleName">
<div style="border:1px solid #a9a9a9;padding:1px;">
եƤɽޤեǤϤʤϡԽǽǤ<br/>
$form
<input type="hidden" name="plugin" value="cgi"/>
<input type="hidden" name="act" value="update"/>
<input type="hidden" name="dir" value="$dir"/>
<input type="hidden" name="file" value="$file"/>
<input type="hidden" name="encode" value="$encode"/>
$FormAuthInfo
</div>
</form>
<br/>
<form method="post" action="$ActionModuleName">
<div style="border:1px solid #a9a9a9;padding:1px;">
ֺץܥ򲡤ȡΥե뤬ޤ<br/>
ΤϡǤޤΤǤդ<br/>
<br/>
<input type="submit" value=""/>
<input type="hidden" name="plugin" value="cgi"/>
<input type="hidden" name="act" value="delfile"/>
<input type="hidden" name="file" value="$file"/>
<input type="hidden" name="dir" value="$dir"/>
$FormAuthInfo
</div>
<br/>
<form method="post" action="$ActionModuleName">
<div style="border:1px solid #a9a9a9;padding:1px;">
եΥѡߥåѹޤ<br/>
777ȻꤵƤ顢̤ϤƤ
<br/>
<input type="text" name="permission"/>
<input type="submit" value="ѹ"/>
<input type="hidden" name="plugin" value="cgi"/>
<input type="hidden" name="act" value="chmod"/>
<input type="hidden" name="file" value="$file"/>
<input type="hidden" name="dir" value="$dir/">
$FormAuthInfo
</div>
</form>
AREA;
			return $return;
		}
		
		/**
		 * deleteFile
		 * ե롣
		 * @param void
		 * @access public
		 * @return void
		 */
		function deleteFile() {
			//ե롣
			//ȤäƤ˥ץ롣
			unlink(PLUGINPATH."cgi/".getRequest('file'));
		}
		
		/**
		 * updateFile
		 * ե򹹿롣
		 * @param void
		 * @access public
		 * @return void
		 */
		function updateFile() {
			//ե򹹿롣
			//λȤʤۤ⤷ʤ
			$editdata = getRequest("editdata");
			if (get_magic_quotes_gpc()) {
				$editdata = stripslashes($editdata);
			}
			
			//ƥ󥳡ɤ
			if ($GLOBALS['Use_mbstring'] == true) {
				//mbstringؿб褦ˤƤΤǡOK
				$editdata = mb_convert_encoding($editdata, getRequest('encode'), "EUC-JP");
			} else {
				$encode = "";
				switch (getRequest('encode')) {
					//¿٤ʤ
					case "EUC-JP":
						$encode = 1;
						break;
					case "SJIS":
						$encode = 2;
						break;
					case "UTF-8":
						$encode = 4;
						break;
				}
				
				$editdata = jcodeConvert($editdata , 1, $encode);
			}
			
			$f = new GFile(PLUGINPATH."cgi/".getRequest("file"));
			$f->clear();
			$f->writeLine($editdata);
			$f->destroy();
		}
		
		/**
		 * changePerFile
		 * եΥѡߥåѹ롣
		 * @param void
		 * @return void
		 */
		function changePerFile() {
			//Ѵϡץ˹Ԥ
			//ȬʿѤΤǡ8Ȥѹ롣
			if (preg_match("/^[0|1|2|4|5|6|7]+$/",getRequest("permission"))) {
				chmod(PLUGINPATH."cgi/".getRequest("file"),intval(getRequest("permission"),8));
			}
		}
	}
?>